unit Bldmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Compress, Segment, ComCtrls, StdCtrls, Buttons;

type
  TBuildForm = class(TForm)
    GroupBox1: TGroupBox;
    ETemplate: TEdit;
    AddBtn: TSpeedButton;
    GroupBox2: TGroupBox;
    TempList: TListBox;
    ClearBtn: TBitBtn;
    BuildBtn: TBitBtn;
    StatusBar: TStatusBar;
    SegCompEZ: TSegCompEZ;
    procedure FormCreate(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure ETemplateEnter(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure BuildBtnClick(Sender: TObject);
    procedure SegCompEZCheckFile(var filepath: String;
      mode: TCProcessMode);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BuildForm: TBuildForm;

implementation

{$R *.DFM}

procedure TBuildForm.FormCreate(Sender: TObject);
begin
     ETemplate.Clear;
     TempList.Clear;
end;

procedure TBuildForm.AddBtnClick(Sender: TObject);
begin
     if (ETemplate.Text <> '') then
       begin
       TempList.Items.Add(ETemplate.Text);
       ETemplate.Clear;
       end;
end;

procedure TBuildForm.ETemplateEnter(Sender: TObject);
begin
     StatusBar.Panels[0].Text := 'Enter template. (ie. c:\Myfiles\*.*)';
end;

procedure TBuildForm.ClearBtnClick(Sender: TObject);
begin
     TempList.Clear;
     ETemplate.Clear;
     ETemplate.SetFocus;
end;

procedure TBuildForm.BuildBtnClick(Sender: TObject);
var
   i:          Integer;
   ifh, ofh:   TFileStream;
   TheSetup:   String;
begin
     DeleteFile('a:\setup.exe');
     TheSetup := ExtractFilePath(ParamStr(0)) + 'setup.exe';
     ifh := TFileStream.Create(TheSetup,fmOpenRead);
     ofh := TFileStream.Create('a:\setup.exe',fmCreate or fmOpenWrite);
     StatusBar.Panels[0].Text := 'Copying ''' + TheSetup + ''' to diskette';
     Statusbar.Update;
     ofh.CopyFrom(ifh,ifh.Size);
     ifh.Free;
     ofh.Free;

     with SegCompEZ do
       begin
       SegBaseName := 'Data';
       SegExt := 'cdf';
       SegBuildMode := bmRecursive;
       SegCompType := coLZH;
       SegDir := 'a:\';
       SegMultiArc := True;
       SegTmpDir := 'c:\temp';
       SegSource.Clear;
       for i := 0 to TempList.Items.Count-1 do
         SegSource.Add(TempList.Items[i]);
       try
         Compress;
         StatusBar.Panels[0].Text := 'Done!';
       except
         ShowMessage('Compress failed!');
       end; {try}
       end;
end;

procedure TBuildForm.SegCompEZCheckFile(var filepath: String;
  mode: TCProcessMode);
begin
     StatusBar.Panels[0].Text := 'Compressing: ' + filepath;
     StatusBar.Update;
end;

end.
